/// <reference types="node" />
import { Duplex } from 'stream';
import type { Document } from 'bson';
import { SchemaAnalyzer } from './schema-analyzer';
import type { SchemaParseOptions } from './schema-analyzer';
export declare class ParseStream extends Duplex {
    analyzer: SchemaAnalyzer;
    schemaPaths: boolean;
    constructor(options?: SchemaParseOptions & {
        schemaPaths?: boolean;
    });
    _write(obj: Document, enc: unknown, cb: () => void): void;
    _read(): void;
    _final(cb: () => void): void;
}
export default function makeParseStream(options?: SchemaParseOptions & {
    schemaPaths?: boolean;
}): ParseStream;
